// ShareViewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ShareView.h"
#include "ShareViewDlg.h"
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShareViewDlg dialog

CShareViewDlg::CShareViewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CShareViewDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CShareViewDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hSmallIcon = AfxGetApp()->LoadIcon(IDI_SMALL);
}

void CShareViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShareViewDlg)
	DDX_Control(pDX, IDC_LEGEND, m_legendList);
	DDX_Control(pDX, IDC_SHARELIST, m_shareList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShareViewDlg, CDialog)
	//{{AFX_MSG_MAP(CShareViewDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_TOGGLE, OnToggle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShareViewDlg message handlers

BOOL CShareViewDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hSmallIcon, FALSE);		// Set small icon
	
	imageList.Create(IDB_IMAGELIST, 16, 0, 0x00ffffff);
	m_legendList.SetImageList(&imageList, LVSIL_SMALL);
	m_legendList.InsertItem(0, "Read", 1);
	m_legendList.InsertItem(1, "Write", 2);
	m_legendList.InsertItem(2, "Read/Password", 3);
	m_legendList.InsertItem(3, "Write/Password", 4);
	m_legendList.InsertItem(4, "Password Dependent", 5);
	m_legendList.InsertItem(5, "Hidden System Share!", 6);
	m_legendList.EnableWindow(FALSE);
	
	m_shareList.SetImageList(&imageList, LVSIL_SMALL);
	m_shareList.InsertColumn(0, "Share", LVCFMT_LEFT, 75, 0);
	m_shareList.InsertColumn(1, "Directory", LVCFMT_LEFT, 200, 1);
	m_shareList.InsertColumn(2, "Write PW", LVCFMT_LEFT, 100, 2);
	m_shareList.InsertColumn(3, "Read PW", LVCFMT_LEFT, 100, 3);
	refreshView();

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CShareViewDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CShareViewDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CShareViewDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CShareViewDlg::OnRefresh() 
{
	refreshView();	
}

void CShareViewDlg::OnToggle() 
{
	HKEY key;
	CString keyName;
	DWORD len;
	DWORD junk;
	DWORD flags;
	int index = m_shareList.GetNextItem(-1, LVNI_SELECTED|LVNI_ALL);

	//Toggle the bit.
	keyName = m_shareList.GetItemText(index, 0);
	keyName = "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Network\\LanMan\\" + keyName;
	RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyName, 0, NULL, &key);
	len = sizeof(flags);
	RegQueryValueEx(key, "Flags", NULL, &junk, (BYTE *)&flags, &len);
	flags = flags ^ 0x200;
	RegSetValueEx(key, "Flags", NULL, REG_DWORD, (BYTE *)&flags, sizeof(flags));
	RegCloseKey(key);

	refreshView();	
}

void CShareViewDlg::refreshView()
{
	HKEY key;
	HKEY subkey;
	DWORD maxKeys;
	DWORD i;
	DWORD len;
	DWORD junk;
	DWORD flags;
	char keyName[256];
	char local[1025];
	char pw1[256];
	char pw2[256];
	int index;
	int image;
	const int read = 1;
	const int write = 2;
	const int hidden = 512;

	m_shareList.DeleteAllItems();
	RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Network\\LanMan", 0, NULL, &key);
	RegQueryInfoKey (key, NULL, NULL, NULL, &maxKeys, NULL, NULL, 
		NULL, NULL, NULL, NULL, NULL);
	for(i=0; i<maxKeys; i++)
	{
		RegEnumKey(key, i, keyName, 256);
		RegOpenKeyEx(key, keyName, 0, NULL, &subkey);
		len = 1025;
		if (RegQueryValueEx(subkey, "Path", NULL, &junk, (BYTE *)local, &len) != ERROR_SUCCESS)
			strcpy(local, "Path over 1024 characters");
		pw1[0] = pw2[0] = 0;
		len = 256;
		RegQueryValueEx(subkey, "Parm1enc", NULL, &junk, (BYTE *)pw1, &len);
		pw1[len] = 0;
		decodePW(pw1);
		len = 256;
		RegQueryValueEx(subkey, "Parm2enc", NULL, &junk, (BYTE *)pw2, &len);
		pw2[len] = 0;
		decodePW(pw2);
		len = sizeof(flags);
		RegQueryValueEx(subkey, "Flags", NULL, &junk, (BYTE *)&flags, &len);
		RegCloseKey(subkey);
		image = 0;
		if ((flags & read)==read) image |= read;
		if ((flags & write)==write) image |= write;
		if ((pw1[0]!=0) && (image!=0)) image += 2;
		if ((pw1[0]!=0) && (pw2[0]!=0) && ((flags & read)==read) && ((flags & write)==write))
			image = 5;
		if ((flags & hidden)==hidden) image = 6;
		index = m_shareList.InsertItem(0, keyName, image);
		m_shareList.SetItemText(index, 1, local);
		m_shareList.SetItemText(index, 2, pw1);
		m_shareList.SetItemText(index, 3, pw2);
	}
	RegCloseKey(key);
}

//Decode the share password using a simple XOR hash algorithm with a
//left rotating 8-bit key.
void CShareViewDlg::decodePW(char * pw)
{
	BYTE hash = 0x35;

	while (pw && *pw)
	{
		*pw = *pw ^ hash;
		pw++;
		hash = rotr(hash);
	}
}

//Microsoft VC++ doesn't have a byte rotate-right function, so I have
//to write my own.  Oh, well.
BYTE CShareViewDlg::rotr(BYTE b)
{
	BYTE carry;
	carry = b & 0x01;
	carry <<= 7;
	b >>= 1;
	b |= carry;
	return b;
}
